Story9/urls.py
from django.contrib import admin
from django.urls import path, include
from django.contrib.auth import views
from .views import *
from django.conf import settings

app_name = 'Story9'

urlpatterns = [
    path('listbook/<str:keyword>',books,name='book'),
    path('mydiary/', fungsi_hello, name='fungsi_hello'),
    path('valid/', valid, name='valid'),
    path('admin/', admin.site.urls),
    path('home/', home, name='home'),
    path('',  login, name="login"),
    path('logout/', views.LogoutView.as_view(),  {'next_page': settings.LOGOUT_REDIRECT_URL}, name='logout'),
    path('logout/', logout_view , name='logout'),
]

StoryTDD/urls.py
from django.contrib import admin
from django.urls import path, include

urlpatterns = [
    path('admin/', admin.site.urls),
    path('', include('Story9.urls')),
    path('auth/', include('social_django.urls', namespace='social'))
]

Story9/models.py
from django.db import models
from datetime import datetime, date

# Create your models here.
class Data(models.Model):
    tgl = models.DateTimeField()
    cat = models.CharField(max_length=30)

    def as_dict(self):
        return {
            "tgl": self.tgl,
            "cat": self.cat,
        }

Story9/forms.py
from django import forms

Story9/views.py
from django.shortcuts import render
from django.http import HttpResponse
from django.http import HttpResponseRedirect
import json
import requests
from django.http import JsonResponse
from .models import Data
from django.contrib.auth import authenticate, login, logout



def books(request, keyword = "quilting"):
    linkJson = requests.get('https://www.googleapis.com/books/v1/volumes?q=' + keyword)
    parse = json.dumps(linkJson.json())
    return HttpResponse(parse)

def home(request):
    return render(request, "book.html")

def fungsi_hello(request):
    if request.method == 'POST':
        tgl = request.POST['tgl']
        cat = request.POST['cat']
        json = Data(tgl= tgl,cat=cat)
        json.save()
        return JsonResponse(json.as_dict())

def valid(request):
    tgl = request.POST.get('tgl', None)
    cat = request.POST.get('cat', None)
    data = {
        'is_taken': Data.objects.filter(tgl=tgl,cat=cat).exists()
    }
    return JsonResponse(data)

def login(request):
    return render(request,'login.html')

def logout_view(request):
    request.session.flush()
    logout(request)
    return HttpResponseRedirect('/searchbook')

Story9/templates/book.html
{% load staticfiles %}
<!DOCTYPE html>
<html lang="id">
<head>
  <title>List of Books</title>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">
  <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.1.3/css/bootstrap.min.css" integrity="sha384-MCw98/SFnGE8fJT3GXwEOngsV7Zt27NXFoaoApmYm81iuXoPkFOJwJ8ERdknLPMO" crossorigin="anonymous">
  <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/4.7.0/css/font-awesome.min.css">
  <link rel="stylesheet" type="text/css" href="{% static 'css/mycss.css' %}">
  <script src="https://code.jquery.com/jquery-1.11.3.min.js"></script>
  <script src="https://code.jquery.com/ui/1.11.4/jquery-ui.min.js"></script>
  <meta name="google-signin-client_id" content="507958782827-2km1po0hp3ggoru9fsemrg84tns6bbdv.apps.googleusercontent.com">
  <script src="https://apis.google.com/js/platform.js" async defer></script>

  <style type="text/css">
		body{
			background: lightblue;
		}
		#myInput{
		  	background-position: right;
		  	background-repeat: no-repeat;
		  	width: 30%;
		  	font-size: 16px;
		  	padding: 12px 20px 12px 40px;
		  	border: 1px solid #ddd;
		  	margin-bottom: 12px;
		}

  </style>
</head>
<body>
<div class="jumbotron">
   <center>
     <h1 class="ml9">
      <span class="text-wrapper">
        <span class="letters">List of Books</span>
      </span>
     </h1>
     <script src="https://cdnjs.cloudflare.com/ajax/libs/animejs/2.0.2/anime.min.js"></script>
   </center>
</div>

<div class="row" style="margin-top: 3%">
  {%if user.is_authenticated%}
  <header class = "m-3" ">
  <a href= "{% url 'Story9:logout'%}" style="text-transform:none; margin-top: 3%;">
    <div class="left">
      <img width="20px" alt="Google &quot;G&quot; Logo" src="https://upload.wikimedia.org/wikipedia/commons/thumb/5/53/Google_%22G%22_Logo.svg/512px-Google_%22G%22_Logo.svg.png"/>
    </div>
    Log Out
  </a>
  <h3 style="text-align: center">Hello, {{ user.username }}!</h3>
  </header>
  {%else%}<header>
  <a href="{% url 'social:begin' 'google-oauth2' %}" style="text-transform:none">
    <div class="left">
      <img width="20px" alt="Google &quot;G&quot; Logo" src="https://upload.wikimedia.org/wikipedia/commons/thumb/5/53/Google_%22G%22_Logo.svg/512px-Google_%22G%22_Logo.svg.png"/>
    </div>
    Login with Google
  </a>
  <br>
</header>
  {%endif%}
</div>


<header class="text-center">
  <div class="container1">
    <div class="centered" id="counter">0</div>
  </div>
  <h4 style="color:darkgrey">Favorites</h4>
</header>
<center>
  <input id = "search_box" placeholder="  type the name of the book" style="min-width: 250px;align-content: center">
  <button type="button" class="btn btn-info" id ="search_button" style ="align-content: center">Search</button>
</center>
<div style="padding-top: 2%; margin-left: 10%;margin-right: 10%;">
  <table id="demo" class="table table-striped table-light table-bordered table-hover">
    <thead class="thead-light">
    <tr>
      <th scope="col" style="text-align: center;">No</th>
      <th scope="col" style="text-align: center;">Cover</th>
      <th scope="col" style="text-align: center;">Title</th>
      <th scope="col" style="text-align: center;">Authors</th>
      <th scope="col" style="text-align: center;">Publisher</th>
      <th scope="col" style="text-align: center;">Published Date</th>
      <th scope="col" style="text-align: center;">Categories</th>
      <th scope="col" style="text-align: center;">Add to Favorites</th>
    </tr>
    </thead>
    <tbody id='myTable'>
    </tbody>
  </table>

</div>

<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.3.1/jquery.min.js"></script>
<script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.14.3/umd/popper.min.js" integrity="sha384-ZMP7rVo3mIykV+2+9J3UJ46jBk0WLaUAdn689aCwoqbBJiSnjAK/l8WvCWPIPm49" crossorigin="anonymous"></script>
<script src="https://stackpath.bootstrapcdn.com/bootstrap/4.1.3/js/bootstrap.min.js" integrity="sha384-ChfqqxuZUCnJSK3+MXmPNIyE6ZbWh2IMqE241rYiqJxyMiZ6OW/JmZQ5stwEULTy" crossorigin="anonymous"></script>

<script src="{% static 'js/myjs.js' %}"></script>
</body>
</html>

Story9/templates/login.html
<head>
  <meta name="google-signin-client_id" content="507958782827-2km1po0hp3ggoru9fsemrg84tns6bbdv.apps.googleusercontent.com">
</head>
<style>
  :root {
  --input-padding-x: 1.5rem;
  --input-padding-y: .75rem;
}

body {
  background: lightgreen;
}

.card-signin {
  border: 0;
  border-radius: 1rem;
  box-shadow: 0 0.5rem 1rem 0 rgba(0, 0, 0, 0.1);
}

.card-signin .card-title {
  margin-bottom: 2rem;
  font-weight: 300;
  font-size: 1.5rem;
}

.card-signin .card-body {
  padding: 2rem;
}

.form-signin {
  width: 100%;
}

.form-signin .btn {
  font-size: 80%;
  border-radius: 5rem;
  letter-spacing: .1rem;
  font-weight: bold;
  padding: 1rem;
  transition: all 0.2s;
}

.form-label-group {
  position: relative;
  margin-bottom: 1rem;
}

.form-label-group input {
  border-radius: 2rem;
}

.form-label-group>input,
.form-label-group>label {
  padding: var(--input-padding-y) var(--input-padding-x);
}

.form-label-group>label {
  position: absolute;
  top: 0;
  left: 0;
  display: block;
  width: 100%;
  margin-bottom: 0;
  /* Override default `<label>` margin */
  line-height: 1.5;
  color: #495057;
  border: 1px solid transparent;
  border-radius: .25rem;
  transition: all .1s ease-in-out;
}

.form-label-group input::-webkit-input-placeholder {
  color: transparent;
}

.form-label-group input:-ms-input-placeholder {
  color: transparent;
}

.form-label-group input::-ms-input-placeholder {
  color: transparent;
}

.form-label-group input::-moz-placeholder {
  color: transparent;
}

.form-label-group input::placeholder {
  color: transparent;
}

.form-label-group input:not(:placeholder-shown) {
  padding-top: calc(var(--input-padding-y) + var(--input-padding-y) * (2 / 3));
  padding-bottom: calc(var(--input-padding-y) / 3);
}

.form-label-group input:not(:placeholder-shown)~label {
  padding-top: calc(var(--input-padding-y) / 3);
  padding-bottom: calc(var(--input-padding-y) / 3);
  font-size: 12px;
  color: #777;
}

.btn-google {
  color: white;
  background-color: tomato;
}

</style>

<body>
<div class="container">
  <div class="row">
    <div class="col-sm-9 col-md-7 col-lg-5 mx-auto">
      <div class="card card-signin my-5">
        <div class="card-body">
        <h1> Login </h1>
            <button class="btn btn-lg btn-google btn-block text-uppercase" type="submit"><i class="fab fa-google mr-2"></i> <a href="{% url 'social:begin' 'google-oauth2' %}">Sign In with Google</a><br></button>
        </div>
      </div>
    </div>
  </div>
</div>
</body>